Subject: Re: [PATCH iproute2] Revert "iproute: "list/flush/save default" selected all of the routes"

From: Luca Boccassi <[email-masked]>
Date: Tue, 13 Mar 2018 12:02:01 +0000

On Tue, 2018-03-13 at 12:05 +0100, Alexander Zubkov wrote:
> Hello again,
> 
> The fun thing is that before the commit "ip route ls all" showed all
> routes, but "ip -[4|6] route ls all" showed only default. So it was
> broken too, but in other way.
> I see parsing of prefix was changed since my patch. So I need several
> days to propose fix. I think if "ip route ls [all|any]" shows all
> routes and "ip route ls default" shows only default, everybody will
> be happy with that?

Hi,

My only concern is that behaviour of existing commands that have been
in releases is not changed, otherwise I get bugs raised :-)

Thank you for your work!

> 13.03.2018, 09:46, "Alexander Zubkov" <[email-masked]>:
> > Hello.
> > 
> > May be the better way would be to change how "all"/"any" argument
> > behaves? My original concern was about "default" only. I agree too,
> > that "all" or "any" should work for all routes. But not for the
> > default.
> > 
> > 12.03.2018, 22:37, "Luca Boccassi" <[email-masked]>:
> > >  On Mon, 2018-03-12 at 14:03 -0700, Stephen Hemminger wrote:
> > > >   This reverts commit 9135c4d6037ff9f1818507bac0049fc44db8c3d2.
> > > > 
> > > >   Debian maintainer found that basic command:
> > > >           # ip route flush all
> > > >   No longer worked as expected which breaks user scripts and
> > > >   expectations. It no longer flushed all IPv4 routes.
> > > > 
> > > >   Reported-by: Luca Boccassi <[email-masked]>
> > > >   Signed-off-by: Stephen Hemminger <[email-masked]>
> > > >   ---
> > > >    ip/iproute.c | 65 ++++++++++++++++++----------------------
> > > > --------
> > > >   ------------
> > > >    lib/utils.c  | 13 ++++++++++++
> > > >    2 files changed, 32 insertions(+), 46 deletions(-)
> > > 
> > >  Tested-by: Luca Boccassi <[email-masked]>
> > > 
> > >  Thanks, solves the problem. I'll backport it to Debian.
> > > 
> > >  Alexander, reproducing the issue is quite simple - before that
> > > commit,
> > >  ip route ls all showed all routes, but with the change it
> > > started
> > >  showing only the default table. Same for ip route flush.
> > > 
> > >  --
> > >  Kind regards,
> > >  Luca Boccassi

-- 
Kind regards,
Luca Boccassi